nbitmask.h File Reference

Provides optimised bitmasks of arbitrary length. More...

`#include <algorithm>`
`#include <iostream>`
`#include "regina-core.h"`
`#include "regina-config.h"`
`#include "utilities/bitmanip.h"`

## Classes

class | regina::NBitmask
| A bitmask that can store arbitrarily many true-or-false bits. More...
class | regina::NBitmask1< T >
| A small but extremely fast bitmask class that can store up to 8 * sizeof(T) true-or-false bits. More...
class | regina::NBitmask2< T, U >
| A small but extremely fast bitmask class that can store up to 8 * sizeof(T) + 8 * sizeof(U) true-or-false bits. More...

## Namespaces

| regina
| Contains the entire Regina calculation engine.

## Typedefs

typedef NBitmask1< unsigned char > | regina::NBitmaskLen8
| A convenience typedef that gives a small and extremely fast bitmask class capable of holding at least 8 true-or-false bits. More...
typedef NBitmask1< unsigned int > | regina::NBitmaskLen16
| A convenience typedef that gives a small and extremely fast bitmask class capable of holding at least 16 true-or-false bits. More...
typedef InternalBitmaskLen32::Type | regina::NBitmaskLen32
| A convenience typedef that gives a small and extremely fast bitmask class capable of holding at least 32 true-or-false bits. More...
typedef InternalBitmaskLen64::Type | regina::NBitmaskLen64
| A convenience typedef that gives a small and extremely fast bitmask class capable of holding at least 64 true-or-false bits. More...

## Functions

REGINA_API std::ostream & | regina::operator<< (std::ostream &out, const NBitmask &mask)
| Writes the given bitmask to the given output stream as a sequence of zeroes and ones. More...
template<typename T >
std::ostream & | regina::operator<< (std::ostream &out, const NBitmask1< T > &mask)
| Writes the given bitmask to the given output stream as a sequence of zeroes and ones. More...
template<typename T , typename U >
std::ostream & | regina::operator<< (std::ostream &out, const NBitmask2< T, U > &mask)
| Writes the given bitmask to the given output stream as a sequence of zeroes and ones. More...

## Detailed Description

Provides optimised bitmasks of arbitrary length.

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).